<?php

namespace Drupal\universal_entity_api\Controller;

use Drupal\Core\Config\ConfigFactoryInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Symfony\Component\HttpFoundation\JsonResponse;
use Drupal\Core\Controller\ControllerBase;

class ConfigController extends ControllerBase {

  protected $configFactory;

  public function __construct(ConfigFactoryInterface $configFactory) {
    $this->configFactory = $configFactory;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('config.factory')
    );
  }

  public function basic() {
    $site_config = $this->configFactory->get('system.site');
    $lang_config = $this->configFactory->get('language.types');
    $date_config = $this->configFactory->get('system.date');

    return new JsonResponse([
      'site_name' => $site_config->get('name'),
      'site_mail' => $site_config->get('mail'),
      'default_language' => $lang_config->get('configurable')[0] ?? 'en',
      'timezone' => $date_config->get('timezone.default'),
    ]);
  }
}
