<?php

namespace Drupal\universal_entity_api\Controller;

use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Controller\ControllerBase;
use Drupal\universal_entity_api\Normalizer\MenuNormalizer;

class MenuApiController extends ControllerBase {

  protected $normalizer;

  public function __construct(MenuNormalizer $normalizer) {
    $this->normalizer = $normalizer;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('universal_entity_api.menu_normalizer')
    );
  }

  public function handle($menu_name) {
    $data = $this->normalizer->normalize($menu_name);
    $response = new JsonResponse($data);
    $response->setMaxAge(3600);
    $response->headers->set('Cache-Control', 'public');
    return $response;
  }
}
