<?php

namespace Drupal\universal_entity_api\Controller;

use Symfony\Component\HttpFoundation\Response;
use Drupal\Core\Controller\ControllerBase;
use function drupal_get_path;

class SwaggerUiController extends ControllerBase {

  /**
   * Display the Swagger UI HTML page.
   *
   * The HTML page served by this method is the standard Swagger UI HTML page
   * that comes with the module. The only modification is that the default
   * Swagger spec URL is replaced with the URL of the OpenAPI specification
   * served by this module.
   *
   * @return \Symfony\Component\HttpFoundation\Response
   *   The HTML page to display.
   */
  public function display() {
    $module_path = \Drupal::service('extension.list.module')->getPath('universal_entity_api');
    $html = file_get_contents($module_path . '/swagger-ui/index.html');

    // Replace default Swagger spec URL with your local one
    $html = str_replace('https://petstore.swagger.io/v2/swagger.json', '/openapi.json', $html);

    return new Response($html, 200, ['Content-Type' => 'text/html']);
  }
}
