<?php
namespace Drupal\universal_entity_api\Normalizer;

use Drupal\Core\Menu\MenuTreeParameters;
use Drupal\Core\Menu\MenuLinkTreeInterface;

class MenuNormalizer {

  protected $menuTree;

  public function __construct(MenuLinkTreeInterface $menuTree) {
    $this->menuTree = $menuTree;
  }

  public function normalize(string $menu_name): array {
    $tree = $this->menuTree->load($menu_name, new MenuTreeParameters());
    $manipulated = $this->menuTree->build($tree);
    return $this->flatten($manipulated['#items']);
  }

  private function flatten(array $items): array {
    return array_map(function ($item) {
      return [
        'title' => $item['title'],
        'url' => $item['url']->toString(),
        'attributes' => $item['attributes']->toArray(),
        'children' => isset($item['below']) ? $this->flatten($item['below']) : [],
      ];
    }, $items);
  }
}
