<?php

namespace Drupal\universal_entity_api\Normalizer;

use Drupal\Core\Entity\EntityInterface;
use Drupal\universal_entity_api\Service\EntitySerializer;
use Symfony\Component\DependencyInjection\ContainerInterface;

class ParagraphNormalizer {

  protected ContainerInterface $container;

  public function __construct(ContainerInterface $container) {
    $this->container = $container;
  }

  protected function getSerializer(): EntitySerializer {
    return $this->container->get('universal_entity_api.serializer');
  }

  public function normalize(array $paragraphs): array {
    return array_map(function (EntityInterface $entity) {
      return $this->getSerializer()->normalize($entity);
    }, $paragraphs);
  }
}
